// Lokales Radar zeigt Flugobjekte, Tanks, Fahrzeuge und wahlweise Personen   [Vienna, 25.02.2012]
// Der Radarbereich wird durch einen blinkenden Ring angezeigt.
//
// Unbekannte Objekte sind blau, freundliche grn, feindliche rot.
//   Bei Flugobjekten wird auch die Hhe angezeigt.
//
// Aufruf: [Radarobjekt, Radarradius, true/false Personen anzeigen] execVM "RadarAll.sqf"
// Beispiel fr Auslser: temp = [player,2000, true] execVM "RadarAll.sqf"

private ["_radar","_radius","_marker","_kind","_rID1","_rID2","_mID","_mc","_mt","_ms","_mx","_h"];

_radar  = _this select 0;
_radius = _this select 1;

//Marker fr Radarreichweite erstellen
_rID1 = createMarkerLocal ["AllRadar4711", position _radar];
_rID1 setMarkerShapeLocal "ELLIPSE";
_rID1 setMarkerBrushLocal "BORDER";
_rID1 setMarkerSizeLocal  [_radius,_radius];
_rID1 setMarkerColorLocal "ColorOrange";
//Marker fr Mittelpunkt erstellen
_rID2 = createMarkerLocal ["AllRadar4712", position _radar];
_rID2 setMarkerTypeLocal  "mil_circle";
_rID2 setMarkerSizeLocal  [.35,.35];
_rID2 setMarkerTextLocal  " Radar";
_rID2 setMarkerColorLocal "ColorOrange";

// _kind = anzuzeigende Objektgruppen
_kind = ["Air","Tank","Car"];
//auch Personen anzeigen?
if (_this select 2) then {_kind = _kind + ["Man"]};

while {alive _radar} do
  {
    //Map offen?
    if (visibleMap) then 
      {
        //Durchlauf aller Objekte im Radarbereich 
        _marker = [];
        {
          if (alive _x) then
            {
              _h = "";         // _h  = fr Hhe von Flugobjekten.
              _ms = [0.9,0.9]; // _ms = Markergre
              // _mt = Markertype
              if (_x isKindOf "Air") then           //Flug-Objekt
                {
                  _mt = "Air";
                  _h = " 0m hoch";
                  if(position _x select 2 > 1)then{_h=" "+str(floor(position _x select 2))+"m hoch"}
                }
              else
                {
                  if (_x isKindOf "Tank") then      //Tank-Objekt 
                    {_mt="Tank"}
                  else
                    {                          
                      if (_x isKindOf "Car") then   //Car-Objekt
                        {_mt="Car";_ms = [0.8,0.5]}
                      else
                        {_mt="Vehicle";_ms = [2,2]} //Men-Objekt
                    }
                };
              // _mc = Markerfarbe: blau=unbekannt, grn=freundlich, rot=feindlich
              // _mx = Markertext
              if(player countUnknown[_x]==1)then{_mx="?";_mc="ColorBlue"}
              else{_mx=typeOf _x;if(player countFriendly[_x]==1)then{_mc="ColorGreen"}
                                else{_mc="ColorRed"}};
              //Marker Erstellen
              _mID = createMarkerLocal [str _x, position _x];
              _mID setMarkerTypeLocal  _mt;
              _mID setMarkerTextLocal  (if(_x isKindOf "Man")then{""}else{str _mx + _h});
              _mID setMarkerColorLocal _mc;
              _mID setMarkerSizeLocal  _ms;
              if(_x==player)then{_mID setMarkerTextLocal "< Player"}; //Spieler markieren
              //Marker ID in Array speichern
              _marker = _marker + [_mID]
            }
        } forEach nearestObjects [_radar,_kind,_radius];
        sleep 3;
        //Marker fr Radar nachstellen
        _rID1 setMarkerPosLocal position _radar;
        _rID2 setMarkerPosLocal position _radar;
        //alle Objektmarker lschen
        {deleteMarkerLocal _x} foreach _marker 
      }
    else
      {
        sleep 2
      }
   };
//Reichweitenmarker lschen
deleteMarkerLocal _rID 

